       IDENTIFICATION DIVISION.
       PROGRAM-ID.    CUSCSVC1.
       AUTHOR.        SIMOTIME TECHNOLOGIES.
      *****************************************************************
      * Copyright (C) 1987-2016   SimoTime Technologies  .            *
      *                                                               *
      * All rights reserved.  Unpublished, all rights reserved under  *
      * copyright law and international treaty.  Use of a copyright   *
      * notice is precautionary only and does not imply publication   *
      * or disclosure.                                                *
      *                                                               *
      * Permission to use, copy, modify and distribute this software  *
      * for any non-commercial purpose and without fee is hereby      *
      * granted, provided the SimoTime copyright notice appear on all *
      * copies of the software. The SimoTime name or Logo may not be  *
      * used in any advertising or publicity pertaining to the use    *
      * of the software without the written permission of SimoTime    *
      * Technologies.                                                 *
      *                                                               *
      * Permission to use, copy, modify and distribute this software  *
      * for any commercial purpose requires a fee to be paid to       *
      * SimoTime Technologies. Once the fee is received by SimoTime   *
      * the latest version of the software will be delivered and a    *
      * license will be granted for use within an enterprise,         *
      * provided the SimoTime copyright notice appear on all copies   *
      * of the software. The SimoTime name or Logo may not be used    *
      * in any advertising or publicity pertaining to the use of the  *
      * software without the written permission of SimoTime           *
      * Technologies.                                                 *
      *                                                               *
      * SimoTime Technologies makes no warranty or representations    *
      * about the suitability of the software for any purpose. It is  *
      * provided "AS IS" without any express or implied warranty,     *
      * including the implied warranties of merchantability, fitness  *
      * for a particular purpose and non-infringement. SimoTime       *
      * Technologies shall not be liable for any direct, indirect,    *
      * special or consequential damages resulting from the loss of   *
      * use, data or projects, whether in an action of contract or    *
      * tort, arising out of or in connection with the use or         *
      * performance of this software                                  *
      *                                                               *
      * SimoTime Technologies                                         *
      * 15 Carnoustie Drive                                           *
      * Novato, CA 94949-5849                                         *
      * 415.883.6565                                                  *
      *                                                               *
      * RESTRICTED RIGHTS LEGEND                                      *
      * Use, duplication, or disclosure by the Government is subject  *
      * to restrictions as set forth in subparagraph (c)(1)(ii) of    *
      * the Rights in Technical Data and Computer Software clause at  *
      * DFARS 52.227-7013 or subparagraphs (c)(1) and (2) of          *
      * Commercial  Computer Software - Restricted Rights  at 48      *
      * CFR 52.227-19, as applicable.  Contact SimoTime Technologies, *
      * 15 Carnoustie Drive, Novato, CA 94949-5849.                   *
      *****************************************************************
      *        This base program was generated by SimoZAPS            *
      *             A product of SimoTime Technologies                *
      *        Our e-mail address is: helpdesk@simotime.com           *
      *     Also, visit our Web Site at http://www.simotime.com       *
      *                                                               *
      *                                   Record    Record     Key    *
      *  Function  Name     Organization  Format    Max-Min  Pos-Len  *
      *  INPUT     CUSTMAST SEQUENTIAL    FIXED      00080            *
      *  OUTPUT    CUSTRCSV ASCII/CRLF    VARIABLE   00080            *
      *                                                               *
      *****************************************************************
       ENVIRONMENT DIVISION.
       INPUT-OUTPUT SECTION.
       FILE-CONTROL.
      *    The LINE SEQUENTIAL file organization is Micro Focus
      *    syntax for an ASCII/Text file.
           SELECT CUSTMAST-FILE ASSIGN to CUSTMAST
                  ORGANIZATION  is INDEXED
                  ACCESS MODE   is SEQUENTIAL
                  RECORD KEY    is CUST-NUMBER
                  FILE STATUS   is CUSTMAST-STATUS.
           SELECT CUSTRCSV-FILE ASSIGN TO CUSTRCSV
                  ORGANIZATION  IS SEQUENTIAL
                  ACCESS MODE   IS SEQUENTIAL
                  FILE STATUS   IS CUSTRCSV-STATUS.

      *****************************************************************
       DATA DIVISION.
       FILE SECTION.

       FD  CUSTMAST-FILE.
       COPY CUSTCB01.

       FD  CUSTRCSV-FILE
           DATA RECORD    IS CUSTRCSV-RECORD.
       01  CUSTRCSV-RECORD.
           05  CUSTRCSV-DATA-01  PIC X(1024).

       WORKING-STORAGE SECTION.
      *****************************************************************
      *    Data-structure for Title and Copyright...
      *    ------------------------------------------------------------
       01  SIM-TITLE.
           05  T1 pic X(11) value '* CUSCSVC1 '.
           05  T2 pic X(34) value 'Export Customer Info to CSV File  '.
           05  T3 pic X(10) value ' v07.11.06'.
           05  T4 pic X(24) value ' http://www.simotime.com'.
       01  SIM-COPYRIGHT.
           05  C1 pic X(11) value '* CUSCSVC1 '.
           05  C2 pic X(20) value 'Copyright 2003-2008 '.
           05  C3 pic X(28) value '    SimoTime Technologies   '.
           05  C4 pic X(20) value ' All Rights Reserved'.

       01  SIM-THANKS-01.
           05  C1 pic X(11) value '* CUSCSVC1 '.
           05  C2 pic X(32) value 'Thank you for using this sample '.
           05  C3 pic X(32) value 'by   SimoTime Technologies      '.
           05  C4 pic X(04) value '    '.

       01  SIM-THANKS-02.
           05  C1 pic X(11) value '* CUSCSVC1 '.
           05  C2 pic X(32) value 'Please send comments or suggesti'.
           05  C3 pic X(32) value 'ons to helpdesk@simotime.com    '.
           05  C4 pic X(04) value '    '.

       01  CUSTMAST-STATUS.
           05  CUSTMAST-STATUS-L   pic X.
           05  CUSTMAST-STATUS-R   pic X.
       01  CUSTMAST-EOF            pic X       value 'N'.
       01  CUSTMAST-OPEN-FLAG      pic X       value 'C'.


       01  CUSTRCSV-STATUS.
           05  CUSTRCSV-STATUS-L   pic X.
           05  CUSTRCSV-STATUS-R   pic X.
       01  CUSTRCSV-OPEN-FLAG      pic X       value 'C'.

       01  IO-STATUS.
           05  IO-STAT1            pic X.
           05  IO-STAT2            pic X.
       01  TWO-BYTES.
           05  TWO-BYTES-LEFT      pic X.
           05  TWO-BYTES-RIGHT     pic X.
       01  TWO-BYTES-BINARY        redefines TWO-BYTES pic 9(4) comp.
       01  IO-STATUS-4             pic 9(4)  value 0.
       01  IO-STATUS-4A            redefines IO-STATUS-4 pic X(4).


      *****************************************************************
      * Message Buffer used by the Z-DISPLAY-MESSAGE-TEXT routine.    *
      *****************************************************************
       01  MESSAGE-BUFFER.
           05  MESSAGE-HEADER      pic X(11)   value '* CUSCSVC1 '.
           05  MESSAGE-TEXT.
               10  MESSAGE-TEXT-1  pic X(68)   value SPACES.
               10  MESSAGE-TEXT-2  pic X(188)  value SPACES.
       01  MESSAGE-BUFFER-SIZE     pic 9(3)    value 267.
       01  MSG-PTR                 pic 9(3)    value 0.
       01  MSG-LEN                 pic 9(3)    value 0.

       01  APPL-RESULT             pic S9(9)   comp.
           88  APPL-AOK            value 0.
           88  APPL-EOF            value 16.

       01  DOUBLE-QUOTE            pic X       value '"'.
       01  DELIMITER-BYTE          pic X       value ','.
       01  WORK-128                pic X(128)  value SPACES.
       01  WORK-50                 pic X(50)   value SPACES.

       01  WORK-NUMBER-70-X.
           05  WORK-NUMBER-70      pic 9(7)    value 0.

       01  DATA-HAS-DELIMITER      pic X       value 'N'.

       01  REMOVE-DELIMITER        pic X       value 'N'.
       01  REMOVE-DOUBLE-QUOTE     pic X       value 'N'.


       01  TRANSLATE-PARAMETER     pic X(3)    value SPACES.

       01  SIG-FIRST               pic 9(3)    value 0.
       01  SIG-LAST                pic 9(3)    value 0.
       01  SIG-LENGTH              pic 9(3)    value 0.
       01  IDX-1                   pic 9(3)    value 0.
       01  IDX-STOP                pic 9(3)    value 0.
       01  CSV-X1                  pic 9(3)    value 0.

       01  UPPER-CASE  pic X(26) value 'ABCDEFGHIJKLMNOPQRSTUVWXYZ'.
       01  LOWER-CASE  pic X(26) value 'abcdefghijklmnopqrstuvwxyz'.

       COPY ASCEBCB1.

      *****************************************************************
       PROCEDURE DIVISION.

           perform Z-POST-COPYRIGHT

           perform CUSTMAST-OPEN
           perform CUSTRCSV-OPEN

           perform until CUSTMAST-STATUS not = '00'
               perform CUSTMAST-READ
      *        If a successful read of the input file and the input
      *        record is not equal to SPACES then create an output.
               if  CUSTMAST-STATUS = '00'
                   perform BUILD-COMMA-DELIMITED-STRING
                   perform POST-STRING-WITH-CLEAR-AFTER
               end-if
           end-perform

           perform CUSTRCSV-CLOSE
           perform CUSTMAST-CLOSE

           perform Z-THANK-YOU

           GOBACK.

      *****************************************************************
       BUILD-COMMA-DELIMITED-STRING.
           add 1 to ZERO giving CSV-X1

           move CUST-NUMBER to WORK-50
           perform PARSE-AND-POST

           move CUST-LAST-NAME to WORK-50
           perform PARSE-AND-POST

           move CUST-FIRST-NAME to WORK-50
           perform PARSE-AND-POST

           move CUST-MID-NAME to WORK-50
           perform PARSE-AND-POST

           move CUST-ADDRESS-1 to WORK-50
           perform PARSE-AND-POST

           move CUST-ADDRESS-2 to WORK-50
           perform PARSE-AND-POST

           move CUST-CITY to WORK-50
           perform PARSE-AND-POST

           move CUST-STATE to WORK-50
           perform PARSE-AND-POST

           move CUST-POSTAL-CODE to WORK-50
           perform PARSE-AND-POST

           move CUST-PHONE-HOME to WORK-50
           perform PARSE-AND-POST

           move CUST-PHONE-WORK to WORK-50
           perform PARSE-AND-POST

           move CUST-PHONE-CELL to WORK-50
           perform PARSE-AND-POST

           add CUST-CREDIT-LIMIT to ZERO giving WORK-NUMBER-70
           move WORK-NUMBER-70 to WORK-50
           perform PARSE-AND-POST

           move CUST-LADATE to WORK-50
           perform PARSE-AND-POST

           move CUST-LATIME to WORK-50
           perform PARSE-AND-POST

           move CUST-TOKEN to WORK-50
           perform PARSE-AND-POST

      *    Set CSV-X1 to position of last character in string and
      *    remove the trailing comma...
           subtract 1 from CSV-X1
           if  WORK-128(CSV-X1:2) = ', '
               move '  ' to WORK-128(CSV-X1:2)
               subtract 1 from CSV-X1
           end-if

           exit.

      *****************************************************************
       CONVERT-CUSTRCSV-RECORD-A2E.
           inspect CUSTRCSV-RECORD converting A-INFO to E-INFO
           exit.

      *****************************************************************
       CONVERT-CUSTRCSV-RECORD-E2A.
           inspect CUSTRCSV-RECORD converting E-INFO to A-INFO
           exit.

      *****************************************************************
       PARSE-AND-POST.
           perform PARSE-WORK-50
           perform POST-WORK-50
           exit.

      *****************************************************************
      * Determine the position within the field of the first and last *
      * significant characters of a text-string within a field.       *
      * Also, determine the length of the text-string within a field. *
      *****************************************************************
       PARSE-WORK-50.
           subtract SIG-FIRST from SIG-FIRST
           subtract SIG-LAST from SIG-LAST
           subtract SIG-LENGTH from SIG-LENGTH

      *    The IDX-STOP is used to stop the perform loop by setting the
      *    number of characters to scan.
           add 50 to ZERO giving IDX-STOP

      *    The following is for performance and will quickly reduce
      *    the number of times the perform loop executes.
           if  WORK-50(26:25) = SPACES
               if  WORK-50(13:13) = SPACES
                   add 12 to ZERO giving IDX-STOP
               else
                   add 25 to ZERO giving IDX-STOP
               end-if
           else
               if  WORK-50(38:13) = SPACES
                   add 37 to ZERO giving IDX-STOP
               else
                   add 50 to ZERO giving IDX-STOP
               end-if
           end-if

           add 1 to ZERO giving IDX-1
           move 'N' to DATA-HAS-DELIMITER
           perform until IDX-1 GREATER THAN IDX-STOP
               if  WORK-50(IDX-1:1) = DELIMITER-BYTE
                   move 'Y' to DATA-HAS-DELIMITER
               end-if
               if  WORK-50(IDX-1:1) not = SPACE
                   add IDX-1 to ZERO giving SIG-LAST
                   if  SIG-FIRST = 0
                       add IDX-1 to ZERO giving SIG-FIRST
                   end-if
               end-if
               add 1 to IDX-1
           end-perform
           if  SIG-FIRST GREATER THAN ZERO
               compute SIG-LENGTH = SIG-LAST - SIG-FIRST + 1
           end-if
           exit.

      *****************************************************************
      * Move the field to the output buffer and insert a trailing     *
      * delimiter character.                                          *
      *****************************************************************
       POST-WORK-50.
      *    The following will insert a leading Double-Quote if the
      *    data string contains a delimiter character.
           if  DATA-HAS-DELIMITER = 'Y'
               move DOUBLE-QUOTE to WORK-128(CSV-X1:1)
               add 1 to CSV-X1
           end-if
      *    The following would be required if the delimiter byte is
      *    to be removed from the data string.
      *    Remove the delimiter characters from the data string.
           if  REMOVE-DELIMITER = 'Y'
               inspect WORK-50(1:IDX-STOP)
                       replacing all DELIMITER-BYTE by SPACE
           end-if
           if  REMOVE-DOUBLE-QUOTE = 'Y'
               inspect WORK-50(1:IDX-STOP)
                       replacing all DOUBLE-QUOTE by SPACE
           end-if
           if  SIG-FIRST GREATER THAN ZERO
               move WORK-50(SIG-FIRST:SIG-LENGTH)
                 to WORK-128(CSV-X1:SIG-LENGTH)
               add SIG-LENGTH to CSV-X1
      *        The following will insert a trailing Double-Quote if
      *        the data string contains a delimiter character.
               if  DATA-HAS-DELIMITER = 'Y'
                   move DOUBLE-QUOTE to WORK-128(CSV-X1:1)
                   add 1 to CSV-X1
               end-if
      *
               move DELIMITER-BYTE to WORK-128(CSV-X1:1)
               add 1 to CSV-X1
           else
               move DELIMITER-BYTE to WORK-128(CSV-X1:1)
               add 1 to CSV-X1
           end-if
           exit.

      *****************************************************************
      * Write the comma delimited record to the output file.          *
      *****************************************************************
       POST-STRING-WITH-CLEAR-AFTER.
           move SPACES   to CUSTRCSV-RECORD
           move WORK-128 to CUSTRCSV-RECORD
           evaluate TRANSLATE-PARAMETER
             when 'E2A' perform CONVERT-CUSTRCSV-RECORD-E2A
             when 'A2E' perform CONVERT-CUSTRCSV-RECORD-A2E
           end-evaluate
           perform CUSTRCSV-WRITE
           move SPACES to WORK-128
           exit.

      *****************************************************************
      * I/O ROUTINES FOR CUSTMAST...                                  *
      *****************************************************************
       CUSTMAST-CLOSE.
           add 8 to ZERO giving APPL-RESULT.
           close CUSTMAST-FILE
           if  CUSTMAST-STATUS = '00'
               subtract APPL-RESULT from APPL-RESULT
           else
               add 12 to ZERO giving APPL-RESULT
           end-if
           if  APPL-AOK
               CONTINUE
           else
               move 'CUSTMAST-Failure-CLOSE...' to MESSAGE-TEXT
               perform Z-DISPLAY-MESSAGE-TEXT
               move CUSTMAST-STATUS to IO-STATUS
               perform Z-DISPLAY-IO-STATUS
               perform Z-ABEND-PROGRAM
           end-if
           exit.
      *---------------------------------------------------------------*
       CUSTMAST-READ.
           read CUSTMAST-FILE
           if  CUSTMAST-STATUS = '00'
               subtract APPL-RESULT from APPL-RESULT
           else
               if  CUSTMAST-STATUS = '10'
                   add 16 to ZERO giving APPL-RESULT
               else
                   add 12 to ZERO giving APPL-RESULT
               end-if
           end-if
           if  APPL-AOK
               CONTINUE
           else
               if  APPL-EOF
                   move 'Y' to CUSTMAST-EOF
               else
                   move 'CUSTMAST-Failure-GET...' to MESSAGE-TEXT
                   perform Z-DISPLAY-MESSAGE-TEXT
                   move CUSTMAST-STATUS to IO-STATUS
                   perform Z-DISPLAY-IO-STATUS
                   perform Z-ABEND-PROGRAM
               end-if
           end-if
           exit.
      *---------------------------------------------------------------*
       CUSTMAST-OPEN.
           add 8 to ZERO giving APPL-RESULT.
           open input CUSTMAST-FILE
           if  CUSTMAST-STATUS = '00'
               subtract APPL-RESULT from APPL-RESULT
               move 'O' to CUSTMAST-OPEN-FLAG
           else
               add 12 to ZERO giving APPL-RESULT
           end-if
           if  APPL-AOK
               CONTINUE
           else
               move 'CUSTMAST-Failure-OPEN...' to MESSAGE-TEXT
               perform Z-DISPLAY-MESSAGE-TEXT
               move CUSTMAST-STATUS to IO-STATUS
               perform Z-DISPLAY-IO-STATUS
               perform Z-ABEND-PROGRAM
           end-if
           exit.

      *****************************************************************
      * I/O ROUTINES FOR CUSTRCSV...                                  *
      *****************************************************************
       CUSTRCSV-WRITE.
           if  CUSTRCSV-OPEN-FLAG = 'C'
               perform CUSTRCSV-OPEN
           end-if
           write CUSTRCSV-RECORD
           if  CUSTRCSV-STATUS = '00'
               subtract APPL-RESULT from APPL-RESULT
           else
               if  CUSTRCSV-STATUS = '10'
                   add 16 to ZERO giving APPL-RESULT
               else
                   add 12 to ZERO giving APPL-RESULT
               end-if
           end-if.
           if  APPL-AOK
               CONTINUE
           else
               move 'CUSTRCSV-Failure-WRITE...' to MESSAGE-TEXT
               perform Z-DISPLAY-MESSAGE-TEXT
               move CUSTRCSV-STATUS to IO-STATUS
               perform Z-DISPLAY-IO-STATUS
               perform Z-ABEND-PROGRAM
           end-if
           exit.
      *---------------------------------------------------------------*
       CUSTRCSV-OPEN.
           add 8 to ZERO giving APPL-RESULT.
           open OUTPUT CUSTRCSV-FILE
           if  CUSTRCSV-STATUS = '00'
               subtract APPL-RESULT from APPL-RESULT
               move 'O' to CUSTRCSV-OPEN-FLAG
           else
               add 12 to ZERO giving APPL-RESULT
           end-if
           if  APPL-AOK
               CONTINUE
           else
               move 'CUSTRCSV-Failure-OPEN...' to MESSAGE-TEXT
               perform Z-DISPLAY-MESSAGE-TEXT
               move CUSTRCSV-STATUS to IO-STATUS
               perform Z-DISPLAY-IO-STATUS
               perform Z-ABEND-PROGRAM
           end-if
           exit.
      *---------------------------------------------------------------*
       CUSTRCSV-CLOSE.
           add 8 to ZERO giving APPL-RESULT.
           close CUSTRCSV-FILE
           if  CUSTRCSV-STATUS = '00'
               subtract APPL-RESULT from APPL-RESULT
               move 'C' to CUSTRCSV-OPEN-FLAG
           else
               add 12 to ZERO giving APPL-RESULT
           end-if
           if  APPL-AOK
               CONTINUE
           else
               move 'CUSTRCSV-Failure-CLOSE...' to MESSAGE-TEXT
               perform Z-DISPLAY-MESSAGE-TEXT
               move CUSTRCSV-STATUS to IO-STATUS
               perform Z-DISPLAY-IO-STATUS
               perform Z-ABEND-PROGRAM
           end-if
           exit.

      *****************************************************************
      * The following Z-ROUTINES provide administrative functions     *
      * for this program.                                             *
      *****************************************************************
      *
      *****************************************************************
      * ABEND the program, post a message to the console and issue    *
      * a STOP RUN.                                                   *
      *****************************************************************
       Z-ABEND-PROGRAM.
           if  MESSAGE-TEXT not = SPACES
               perform Z-DISPLAY-MESSAGE-TEXT
           end-if
           move 'PROGRAM-IS-ABENDING...'  to MESSAGE-TEXT
           perform Z-DISPLAY-MESSAGE-TEXT
           add 12 to ZERO giving RETURN-CODE
           STOP RUN.
      *    exit.

      *****************************************************************
      * Display CONSOLE messages...                                   *
      *****************************************************************
       Z-DISPLAY-MESSAGE-TEXT.
           display MESSAGE-BUFFER
           move all SPACES to MESSAGE-TEXT
           exit.

      *****************************************************************
      * Display the file status bytes. This routine will display as   *
      * four digits. If the full two byte file status is numeric it   *
      * will display as 00nn. If the 1st byte is a numeric nine (9)   *
      * the second byte will be treated as a binary number and will   *
      * display as 9nnn.                                              *
      *****************************************************************
       Z-DISPLAY-IO-STATUS.
           if  IO-STATUS not NUMERIC
           or  IO-STAT1 = '9'
               subtract TWO-BYTES-BINARY from TWO-BYTES-BINARY
               move IO-STAT2 to TWO-BYTES-RIGHT
               add TWO-BYTES-BINARY to ZERO giving IO-STATUS-4
               move IO-STAT1 to IO-STATUS-4A(1:1)
               move 'File Status is: nnnn' to MESSAGE-TEXT
               move IO-STATUS-4A to MESSAGE-TEXT(17:4)
               perform Z-DISPLAY-MESSAGE-TEXT
           else
               move '0000' to IO-STATUS-4A
               move IO-STATUS to IO-STATUS-4A(3:2)
               move 'File Status is: nnnn' to MESSAGE-TEXT
               move IO-STATUS-4A to MESSAGE-TEXT(17:4)
               perform Z-DISPLAY-MESSAGE-TEXT
           end-if
           exit.

      *****************************************************************
       Z-POST-COPYRIGHT.
           display SIM-TITLE
           display SIM-COPYRIGHT
           exit.

      *****************************************************************
       Z-THANK-YOU.
           display SIM-THANKS-01
           display SIM-THANKS-02
           exit.

      *****************************************************************
      *                 This program is provided by:                  *
      *                    SimoTime Technologies                      *
      *         (C) Copyright 1987-2016 All Rights Reserved           *
      *           Web Site URL:   http://www.simotime.com             *
      *                 e-mail:   helpdesk@simotime.com               *
      *****************************************************************
